## [**Parser**](reference/parser.md)

## [**Project**](reference/project.md)

---

## Events

### [Event](reference/event.md#Event)

::: pyflp.event.Event
    selection:
      members:
        - __init__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [ByteEvent](reference/event.md#ByteEvent)

::: pyflp.event.ByteEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [WordEvent](reference/event.md#WordEvent)

::: pyflp.event.WordEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [DWordEvent](reference/event.md#DWordEvent)

::: pyflp.event.DWordEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [TextEvent](reference/event.md#TextEvent)

::: pyflp.event.TextEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [DataEvent](reference/event.md#DataEvent)

::: pyflp.event.DataEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

### [ColorEvent](reference/event.md#ColorEvent)

::: pyflp.event.ColorEvent
    selection:
      members:
        - __doc__
    rendering:
      show_source: false
      show_root_toc_entry: false

---

# FLP Object Model

## [_FLObject](reference/flobject.md)

---

## [Arrangement](reference/arrangement.md#Arrangement)

### [Playlist](reference/arrangement.md#Playlist)

### [TimeMarker](reference/arrangement.md#TimeMarker)

### [Track](reference/arrangement.md#Track)

---

## [Channel](reference/channel.md#Channel)

### [ChannelArp](reference/channel.md#ChannelArp)

### [ChannelFX](reference/channel.md#ChannelFX)

### [ChannelDelay](reference/channel.md#ChannelDelay)

### [ChannelEnvelopeLFO](reference/channel.md#ChannelEnvelopeLFO)

### [ChannelLevels](reference/channel.md#ChannelLevels)

### [ChannelLevelOffsets](reference/channel.md#ChannelLevelOffsets)

### [ChannelPolyphony](reference/channel.md#ChannelPolyphony)

### [ChannelTracking](reference/channel.md#ChannelTracking)

## [Filter](reference/channel.md#Filter)

---

## [Insert](reference/insert.md#Insert)

### [InsertSlot](reference/insert.md#InsertSlot)

---

## [Misc](reference/misc.md)

---

## [Pattern](reference/pattern.md#Pattern)

### [PatternController](reference/pattern.md#PatternController)

### [PatternNote](reference/pattern.md#PatternNote)

---

## [Plugin](reference/plugin.md#Plugin)

### [VSTPlugin](reference/plugin.md#VSTPlugin)

---

Implementation of `Plugin` for these native FX plugins:

### [Fruity Balance](reference/plugin.md#Fruity-Balance)

### [Fruity Fast Dist](reference/plugin.md#Fruity-Fast-Dist)

### [Fruity Notebook 2](reference/plugin.md#Fruity-Notebook-2)

### [Fruity Send](reference/plugin.md#Fruity-Send)

### [Fruity Soft Clipper](reference/plugin.md#Fruity-Soft-Clipper)

### [Soundgoodizer](reference/plugin.md#Soundgoodizer)

---

Implementation of `Plugin` for these native generator plugins:

### [BooBass](reference/plugin/boobass.md)

---

## [Constants](reference/constants.md)

## [Exceptions](reference/exceptions.md)

## [Utils](reference/utils.md)
